
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega64
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega64
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x10FF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	CALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _g=R5
	.DEF _h=R4
	.DEF _i=R7
	.DEF _count_int=R6
	.DEF _Rx_End=R9
	.DEF _rx_wr_index0=R8
	.DEF _rx_rd_index0=R11
	.DEF _rx_counter0=R10
	.DEF __lcd_x=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usart0_rx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0

_0x0:
	.DB  0x52,0x0,0x4C,0x0,0x5F,0x5F,0x2D,0x2D
	.DB  0x2D,0x2D,0x0,0x45,0x52,0x52,0x0,0x5F
	.DB  0x47,0x5F,0x2D,0x2D,0x2D,0x2D,0x0,0x4E
	.DB  0x5F,0x5F,0x2D,0x2D,0x2D,0x2D,0x0,0x4E
	.DB  0x47,0x5F,0x2D,0x2D,0x2D,0x2D,0x0,0x5F
	.DB  0x5F,0x5F,0x4B,0x52,0x55,0x47,0x0,0x5F
	.DB  0x47,0x5F,0x4B,0x52,0x55,0x47,0x0,0x4E
	.DB  0x5F,0x5F,0x4B,0x52,0x55,0x47,0x0,0x4E
	.DB  0x47,0x5F,0x4B,0x52,0x55,0x47,0x0,0x5F
	.DB  0x5F,0x5F,0x4E,0x41,0x50,0x52,0x0,0x5F
	.DB  0x47,0x5F,0x4E,0x41,0x50,0x52,0x0,0x4E
	.DB  0x5F,0x5F,0x4E,0x41,0x50,0x52,0x0,0x4E
	.DB  0x47,0x5F,0x4E,0x41,0x50,0x52,0x0,0x5F
	.DB  0x5F,0x5F,0x2D,0x2D,0x2D,0x2D,0x0,0x5F
	.DB  0x5F,0x5F,0x5F,0x5F,0x52,0x50,0x4D,0x0
	.DB  0x53,0x54,0x41,0x52,0x54,0x5F,0x5F,0x5F
	.DB  0x0,0x53,0x54,0x41,0x52,0x54,0x52,0x50
	.DB  0x4D,0x0,0x5F,0x5F,0x5F,0x5F,0x5F,0x5F
	.DB  0x0,0x45,0x52,0x52,0x5F,0x5F,0x5F,0x5F
	.DB  0x5F,0x70,0x0,0x45,0x52,0x52,0x5F,0x5F
	.DB  0x5F,0x5F,0x50,0x5F,0x0,0x45,0x52,0x52
	.DB  0x5F,0x5F,0x5F,0x5F,0x50,0x70,0x0,0x45
	.DB  0x52,0x52,0x5F,0x5F,0x5F,0x34,0x5F,0x5F
	.DB  0x0,0x45,0x52,0x52,0x5F,0x5F,0x5F,0x34
	.DB  0x5F,0x70,0x0,0x45,0x52,0x52,0x5F,0x5F
	.DB  0x5F,0x34,0x50,0x5F,0x0,0x45,0x52,0x52
	.DB  0x5F,0x5F,0x33,0x5F,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x5F,0x5F,0x33,0x5F,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x5F,0x5F,0x33,0x5F
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x5F,0x5F
	.DB  0x33,0x5F,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x5F,0x5F,0x33,0x34,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x5F,0x5F,0x33,0x34,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x5F,0x5F,0x33,0x34
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x5F,0x5F
	.DB  0x33,0x34,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x5F,0x32,0x5F,0x5F,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x5F,0x32,0x5F,0x5F,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x5F,0x32,0x5F,0x5F
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x5F,0x32
	.DB  0x5F,0x5F,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x5F,0x32,0x5F,0x34,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x5F,0x32,0x5F,0x34,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x5F,0x32,0x5F,0x34
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x5F,0x32
	.DB  0x5F,0x34,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x5F,0x32,0x33,0x5F,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x5F,0x32,0x33,0x5F,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x5F,0x32,0x33,0x5F
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x5F,0x32
	.DB  0x33,0x5F,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x5F,0x32,0x33,0x34,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x5F,0x32,0x33,0x34,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x5F,0x32,0x33,0x34
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x5F,0x32
	.DB  0x33,0x34,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x5F,0x5F,0x5F,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x5F,0x5F,0x5F,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x5F,0x5F,0x5F
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x5F
	.DB  0x5F,0x5F,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x5F,0x5F,0x34,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x5F,0x5F,0x34,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x5F,0x5F,0x34
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x5F
	.DB  0x5F,0x34,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x5F,0x33,0x5F,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x5F,0x33,0x5F,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x5F,0x33,0x5F
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x5F
	.DB  0x33,0x5F,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x5F,0x33,0x34,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x5F,0x33,0x34,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x5F,0x33,0x34
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x5F
	.DB  0x33,0x34,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x32,0x5F,0x5F,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x32,0x5F,0x5F,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x32,0x5F,0x5F
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x32
	.DB  0x5F,0x5F,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x32,0x5F,0x34,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x32,0x5F,0x34,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x32,0x5F,0x34
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x32
	.DB  0x5F,0x34,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x32,0x33,0x5F,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x32,0x33,0x5F,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x32,0x33,0x5F
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x32
	.DB  0x33,0x5F,0x50,0x70,0x0,0x45,0x52,0x52
	.DB  0x31,0x32,0x33,0x34,0x5F,0x5F,0x0,0x45
	.DB  0x52,0x52,0x31,0x32,0x33,0x34,0x5F,0x70
	.DB  0x0,0x45,0x52,0x52,0x31,0x32,0x33,0x34
	.DB  0x50,0x5F,0x0,0x45,0x52,0x52,0x31,0x32
	.DB  0x33,0x34,0x50,0x70,0x0,0x41,0x5A,0x3A
	.DB  0x0
_0x2020003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x06
	.DW  0x06
	.DW  __REG_VARS*2

	.DW  0x02
	.DW  _0x22
	.DW  _0x0*2

	.DW  0x02
	.DW  _0x22+2
	.DW  _0x0*2+2

	.DW  0x07
	.DW  _0x22+4
	.DW  _0x0*2+4

	.DW  0x04
	.DW  _0x22+11
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+15
	.DW  _0x0*2+15

	.DW  0x04
	.DW  _0x22+23
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+27
	.DW  _0x0*2+23

	.DW  0x04
	.DW  _0x22+35
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+39
	.DW  _0x0*2+31

	.DW  0x08
	.DW  _0x22+47
	.DW  _0x0*2+39

	.DW  0x04
	.DW  _0x22+55
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+59
	.DW  _0x0*2+47

	.DW  0x04
	.DW  _0x22+67
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+71
	.DW  _0x0*2+55

	.DW  0x04
	.DW  _0x22+79
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+83
	.DW  _0x0*2+63

	.DW  0x08
	.DW  _0x22+91
	.DW  _0x0*2+71

	.DW  0x04
	.DW  _0x22+99
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+103
	.DW  _0x0*2+79

	.DW  0x04
	.DW  _0x22+111
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+115
	.DW  _0x0*2+87

	.DW  0x04
	.DW  _0x22+123
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+127
	.DW  _0x0*2+95

	.DW  0x08
	.DW  _0x22+135
	.DW  _0x0*2+103

	.DW  0x04
	.DW  _0x22+143
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+147
	.DW  _0x0*2+15

	.DW  0x04
	.DW  _0x22+155
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+159
	.DW  _0x0*2+23

	.DW  0x04
	.DW  _0x22+167
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+171
	.DW  _0x0*2+31

	.DW  0x08
	.DW  _0x22+179
	.DW  _0x0*2+103

	.DW  0x09
	.DW  _0x22+187
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+196
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+200
	.DW  _0x0*2+15

	.DW  0x09
	.DW  _0x22+208
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+217
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+221
	.DW  _0x0*2+23

	.DW  0x09
	.DW  _0x22+229
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+238
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+242
	.DW  _0x0*2+31

	.DW  0x09
	.DW  _0x22+250
	.DW  _0x0*2+111

	.DW  0x08
	.DW  _0x22+259
	.DW  _0x0*2+39

	.DW  0x09
	.DW  _0x22+267
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+276
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+280
	.DW  _0x0*2+47

	.DW  0x09
	.DW  _0x22+288
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+297
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+301
	.DW  _0x0*2+55

	.DW  0x09
	.DW  _0x22+309
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+318
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+322
	.DW  _0x0*2+63

	.DW  0x09
	.DW  _0x22+330
	.DW  _0x0*2+111

	.DW  0x08
	.DW  _0x22+339
	.DW  _0x0*2+71

	.DW  0x09
	.DW  _0x22+347
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+356
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+360
	.DW  _0x0*2+79

	.DW  0x09
	.DW  _0x22+368
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+377
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+381
	.DW  _0x0*2+87

	.DW  0x09
	.DW  _0x22+389
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+398
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+402
	.DW  _0x0*2+95

	.DW  0x09
	.DW  _0x22+410
	.DW  _0x0*2+111

	.DW  0x08
	.DW  _0x22+419
	.DW  _0x0*2+103

	.DW  0x09
	.DW  _0x22+427
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+436
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+440
	.DW  _0x0*2+15

	.DW  0x09
	.DW  _0x22+448
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+457
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+461
	.DW  _0x0*2+23

	.DW  0x09
	.DW  _0x22+469
	.DW  _0x0*2+111

	.DW  0x04
	.DW  _0x22+478
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+482
	.DW  _0x0*2+31

	.DW  0x09
	.DW  _0x22+490
	.DW  _0x0*2+111

	.DW  0x08
	.DW  _0x22+499
	.DW  _0x0*2+103

	.DW  0x09
	.DW  _0x22+507
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+516
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+520
	.DW  _0x0*2+15

	.DW  0x09
	.DW  _0x22+528
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+537
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+541
	.DW  _0x0*2+23

	.DW  0x09
	.DW  _0x22+549
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+558
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+562
	.DW  _0x0*2+31

	.DW  0x09
	.DW  _0x22+570
	.DW  _0x0*2+120

	.DW  0x08
	.DW  _0x22+579
	.DW  _0x0*2+39

	.DW  0x09
	.DW  _0x22+587
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+596
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+600
	.DW  _0x0*2+47

	.DW  0x09
	.DW  _0x22+608
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+617
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+621
	.DW  _0x0*2+55

	.DW  0x09
	.DW  _0x22+629
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+638
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+642
	.DW  _0x0*2+63

	.DW  0x09
	.DW  _0x22+650
	.DW  _0x0*2+120

	.DW  0x08
	.DW  _0x22+659
	.DW  _0x0*2+71

	.DW  0x09
	.DW  _0x22+667
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+676
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+680
	.DW  _0x0*2+79

	.DW  0x09
	.DW  _0x22+688
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+697
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+701
	.DW  _0x0*2+87

	.DW  0x09
	.DW  _0x22+709
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+718
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+722
	.DW  _0x0*2+95

	.DW  0x09
	.DW  _0x22+730
	.DW  _0x0*2+120

	.DW  0x08
	.DW  _0x22+739
	.DW  _0x0*2+103

	.DW  0x09
	.DW  _0x22+747
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+756
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+760
	.DW  _0x0*2+15

	.DW  0x09
	.DW  _0x22+768
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+777
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+781
	.DW  _0x0*2+23

	.DW  0x09
	.DW  _0x22+789
	.DW  _0x0*2+120

	.DW  0x04
	.DW  _0x22+798
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+802
	.DW  _0x0*2+31

	.DW  0x09
	.DW  _0x22+810
	.DW  _0x0*2+120

	.DW  0x08
	.DW  _0x22+819
	.DW  _0x0*2+103

	.DW  0x09
	.DW  _0x22+827
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+836
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+840
	.DW  _0x0*2+15

	.DW  0x09
	.DW  _0x22+848
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+857
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+861
	.DW  _0x0*2+23

	.DW  0x09
	.DW  _0x22+869
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+878
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+882
	.DW  _0x0*2+31

	.DW  0x09
	.DW  _0x22+890
	.DW  _0x0*2+129

	.DW  0x08
	.DW  _0x22+899
	.DW  _0x0*2+39

	.DW  0x09
	.DW  _0x22+907
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+916
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+920
	.DW  _0x0*2+47

	.DW  0x09
	.DW  _0x22+928
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+937
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+941
	.DW  _0x0*2+55

	.DW  0x09
	.DW  _0x22+949
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+958
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+962
	.DW  _0x0*2+63

	.DW  0x09
	.DW  _0x22+970
	.DW  _0x0*2+129

	.DW  0x08
	.DW  _0x22+979
	.DW  _0x0*2+71

	.DW  0x09
	.DW  _0x22+987
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+996
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+1000
	.DW  _0x0*2+79

	.DW  0x09
	.DW  _0x22+1008
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+1017
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+1021
	.DW  _0x0*2+87

	.DW  0x09
	.DW  _0x22+1029
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+1038
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+1042
	.DW  _0x0*2+95

	.DW  0x09
	.DW  _0x22+1050
	.DW  _0x0*2+129

	.DW  0x08
	.DW  _0x22+1059
	.DW  _0x0*2+103

	.DW  0x09
	.DW  _0x22+1067
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+1076
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+1080
	.DW  _0x0*2+15

	.DW  0x09
	.DW  _0x22+1088
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+1097
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+1101
	.DW  _0x0*2+23

	.DW  0x09
	.DW  _0x22+1109
	.DW  _0x0*2+129

	.DW  0x04
	.DW  _0x22+1118
	.DW  _0x0*2+11

	.DW  0x08
	.DW  _0x22+1122
	.DW  _0x0*2+31

	.DW  0x09
	.DW  _0x22+1130
	.DW  _0x0*2+129

	.DW  0x07
	.DW  _0x22+1139
	.DW  _0x0*2+138

	.DW  0x0A
	.DW  _0x22+1146
	.DW  _0x0*2+145

	.DW  0x0A
	.DW  _0x22+1156
	.DW  _0x0*2+155

	.DW  0x0A
	.DW  _0x22+1166
	.DW  _0x0*2+165

	.DW  0x0A
	.DW  _0x22+1176
	.DW  _0x0*2+175

	.DW  0x0A
	.DW  _0x22+1186
	.DW  _0x0*2+185

	.DW  0x0A
	.DW  _0x22+1196
	.DW  _0x0*2+195

	.DW  0x0A
	.DW  _0x22+1206
	.DW  _0x0*2+185

	.DW  0x0A
	.DW  _0x22+1216
	.DW  _0x0*2+205

	.DW  0x0A
	.DW  _0x22+1226
	.DW  _0x0*2+215

	.DW  0x0A
	.DW  _0x22+1236
	.DW  _0x0*2+225

	.DW  0x0A
	.DW  _0x22+1246
	.DW  _0x0*2+235

	.DW  0x0A
	.DW  _0x22+1256
	.DW  _0x0*2+245

	.DW  0x0A
	.DW  _0x22+1266
	.DW  _0x0*2+255

	.DW  0x0A
	.DW  _0x22+1276
	.DW  _0x0*2+265

	.DW  0x0A
	.DW  _0x22+1286
	.DW  _0x0*2+275

	.DW  0x0A
	.DW  _0x22+1296
	.DW  _0x0*2+285

	.DW  0x0A
	.DW  _0x22+1306
	.DW  _0x0*2+295

	.DW  0x0A
	.DW  _0x22+1316
	.DW  _0x0*2+305

	.DW  0x0A
	.DW  _0x22+1326
	.DW  _0x0*2+315

	.DW  0x0A
	.DW  _0x22+1336
	.DW  _0x0*2+325

	.DW  0x0A
	.DW  _0x22+1346
	.DW  _0x0*2+335

	.DW  0x0A
	.DW  _0x22+1356
	.DW  _0x0*2+345

	.DW  0x0A
	.DW  _0x22+1366
	.DW  _0x0*2+355

	.DW  0x0A
	.DW  _0x22+1376
	.DW  _0x0*2+365

	.DW  0x0A
	.DW  _0x22+1386
	.DW  _0x0*2+375

	.DW  0x0A
	.DW  _0x22+1396
	.DW  _0x0*2+385

	.DW  0x0A
	.DW  _0x22+1406
	.DW  _0x0*2+395

	.DW  0x0A
	.DW  _0x22+1416
	.DW  _0x0*2+405

	.DW  0x0A
	.DW  _0x22+1426
	.DW  _0x0*2+415

	.DW  0x0A
	.DW  _0x22+1436
	.DW  _0x0*2+425

	.DW  0x0A
	.DW  _0x22+1446
	.DW  _0x0*2+435

	.DW  0x0A
	.DW  _0x22+1456
	.DW  _0x0*2+445

	.DW  0x0A
	.DW  _0x22+1466
	.DW  _0x0*2+455

	.DW  0x0A
	.DW  _0x22+1476
	.DW  _0x0*2+465

	.DW  0x0A
	.DW  _0x22+1486
	.DW  _0x0*2+475

	.DW  0x0A
	.DW  _0x22+1496
	.DW  _0x0*2+485

	.DW  0x0A
	.DW  _0x22+1506
	.DW  _0x0*2+495

	.DW  0x0A
	.DW  _0x22+1516
	.DW  _0x0*2+505

	.DW  0x0A
	.DW  _0x22+1526
	.DW  _0x0*2+515

	.DW  0x0A
	.DW  _0x22+1536
	.DW  _0x0*2+525

	.DW  0x0A
	.DW  _0x22+1546
	.DW  _0x0*2+535

	.DW  0x0A
	.DW  _0x22+1556
	.DW  _0x0*2+545

	.DW  0x0A
	.DW  _0x22+1566
	.DW  _0x0*2+555

	.DW  0x0A
	.DW  _0x22+1576
	.DW  _0x0*2+565

	.DW  0x0A
	.DW  _0x22+1586
	.DW  _0x0*2+575

	.DW  0x0A
	.DW  _0x22+1596
	.DW  _0x0*2+585

	.DW  0x0A
	.DW  _0x22+1606
	.DW  _0x0*2+595

	.DW  0x0A
	.DW  _0x22+1616
	.DW  _0x0*2+605

	.DW  0x0A
	.DW  _0x22+1626
	.DW  _0x0*2+615

	.DW  0x0A
	.DW  _0x22+1636
	.DW  _0x0*2+625

	.DW  0x0A
	.DW  _0x22+1646
	.DW  _0x0*2+635

	.DW  0x0A
	.DW  _0x22+1656
	.DW  _0x0*2+645

	.DW  0x0A
	.DW  _0x22+1666
	.DW  _0x0*2+655

	.DW  0x0A
	.DW  _0x22+1676
	.DW  _0x0*2+665

	.DW  0x0A
	.DW  _0x22+1686
	.DW  _0x0*2+675

	.DW  0x0A
	.DW  _0x22+1696
	.DW  _0x0*2+685

	.DW  0x0A
	.DW  _0x22+1706
	.DW  _0x0*2+695

	.DW  0x0A
	.DW  _0x22+1716
	.DW  _0x0*2+705

	.DW  0x0A
	.DW  _0x22+1726
	.DW  _0x0*2+715

	.DW  0x0A
	.DW  _0x22+1736
	.DW  _0x0*2+725

	.DW  0x0A
	.DW  _0x22+1746
	.DW  _0x0*2+735

	.DW  0x0A
	.DW  _0x22+1756
	.DW  _0x0*2+745

	.DW  0x0A
	.DW  _0x22+1766
	.DW  _0x0*2+755

	.DW  0x04
	.DW  _0x22+1776
	.DW  _0x0*2+765

	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 28.07.2015
;Author  :
;Company :
;Comments:
;
;
;Chip type               : ATmega64
;Program type            : Application
;AVR Core Clock frequency: 4,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 1024
;*******************************************************/
;#include <stdio.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <mega64.h>
;#include <alcd.h>
;#include <delay.h>
;#define DATA_REGISTER_EMPTY (1<<UDRE0)
;#define RX_COMPLETE (1<<RXC0)
;#define FRAMING_ERROR (1<<FE0)
;#define PARITY_ERROR (1<<UPE0)
;#define DATA_OVERRUN (1<<DOR0)
;#define RX_BUFFER_SIZE0 8
;char rx_buffer0[RX_BUFFER_SIZE0];
;unsigned char g;
;unsigned char h;
;unsigned char i;
;unsigned char data[1];
;unsigned char count_int=0;
;unsigned char Rx_End=0;
;#if RX_BUFFER_SIZE0 <= 256
;unsigned char rx_wr_index0=0,rx_rd_index0=0;
;#else
;unsigned int rx_wr_index0=0,rx_rd_index0=0;
;#endif
;#if RX_BUFFER_SIZE0 < 256
;unsigned char rx_counter0=0;
;#else
;unsigned int rx_counter0=0;
;#endif
;bit rx_buffer_overflow0;
;interrupt [USART0_RXC] void usart0_rx_isr(void)
; 0000 0034 {

	.CSEG
_usart0_rx_isr:
; .FSTART _usart0_rx_isr
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0035 data[count_int]=UDR0;
	MOV  R26,R6
	LDI  R27,0
	SUBI R26,LOW(-_data)
	SBCI R27,HIGH(-_data)
	IN   R30,0xC
	ST   X,R30
; 0000 0036 count_int++;
	INC  R6
; 0000 0037 if (count_int==1)
	LDI  R30,LOW(1)
	CP   R30,R6
	BRNE _0x3
; 0000 0038 {
; 0000 0039 count_int=0;
	CLR  R6
; 0000 003A }
; 0000 003B 
; 0000 003C    }
_0x3:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
; .FEND
;
;#ifndef _DEBUG_TERMINAL_IO_
;#define _ALTERNATE_GETCHAR_
;#pragma used+
;char getchar(void)
; 0000 0042 {
; 0000 0043 char data;
; 0000 0044 while (rx_counter0==0);
;	data -> R17
; 0000 0045 data=rx_buffer0[rx_rd_index0++];
; 0000 0046 #if RX_BUFFER_SIZE0 != 256
; 0000 0047 if (rx_rd_index0 == RX_BUFFER_SIZE0) rx_rd_index0=0;
; 0000 0048 #endif
; 0000 0049 #asm("cli")
; 0000 004A --rx_counter0;
; 0000 004B #asm("sei")
; 0000 004C return data;
; 0000 004D }
;#pragma used-
;#endif
;
;
;void main(void)
; 0000 0053 {
_main:
; .FSTART _main
; 0000 0054 DDRA=(0<<DDA7) | (0<<DDA6) | (0<<DDA5) | (0<<DDA4) | (0<<DDA3) | (0<<DDA2) | (0<<DDA1) | (0<<DDA0);
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 0055 PORTA=(0<<PORTA7) | (0<<PORTA6) | (0<<PORTA5) | (0<<PORTA4) | (0<<PORTA3) | (0<<PORTA2) | (0<<PORTA1) | (0<<PORTA0);
	OUT  0x1B,R30
; 0000 0056 DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (0<<DDB1) | (0<<DDB0);
	OUT  0x17,R30
; 0000 0057 PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);
	OUT  0x18,R30
; 0000 0058 DDRC=(0<<DDC7) | (0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
	OUT  0x14,R30
; 0000 0059 PORTC=(0<<PORTC7) | (0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	OUT  0x15,R30
; 0000 005A DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
	OUT  0x11,R30
; 0000 005B PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
	OUT  0x12,R30
; 0000 005C DDRE=(0<<DDE7) | (0<<DDE6) | (0<<DDE5) | (1<<DDE4) | (0<<DDE3) | (0<<DDE2) | (0<<DDE1) | (0<<DDE0);
	LDI  R30,LOW(16)
	OUT  0x2,R30
; 0000 005D PORTE=(0<<PORTE7) | (0<<PORTE6) | (0<<PORTE5) | (0<<PORTE4) | (0<<PORTE3) | (0<<PORTE2) | (0<<PORTE1) | (0<<PORTE0);
	LDI  R30,LOW(0)
	OUT  0x3,R30
; 0000 005E DDRF=(0<<DDF7) | (0<<DDF6) | (0<<DDF5) | (0<<DDF4) | (0<<DDF3) | (0<<DDF2) | (0<<DDF1) | (0<<DDF0);
	STS  97,R30
; 0000 005F PORTF=(0<<PORTF7) | (0<<PORTF6) | (0<<PORTF5) | (0<<PORTF4) | (0<<PORTF3) | (0<<PORTF2) | (0<<PORTF1) | (0<<PORTF0);
	STS  98,R30
; 0000 0060 DDRG=(0<<DDG4) | (0<<DDG3) | (0<<DDG2) | (0<<DDG1) | (0<<DDG0);
	STS  100,R30
; 0000 0061 PORTG=(0<<PORTG4) | (0<<PORTG3) | (0<<PORTG2) | (0<<PORTG1) | (0<<PORTG0);
	STS  101,R30
; 0000 0062 ASSR=0<<AS0;
	OUT  0x30,R30
; 0000 0063 TCCR0=(0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (0<<CS02) | (0<<CS01) | (0<<CS00);
	OUT  0x33,R30
; 0000 0064 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0065 OCR0=0x00;
	OUT  0x31,R30
; 0000 0066 TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<COM1C1) | (0<<COM1C0) | (0<<WGM11) | (0<<WGM10);
	OUT  0x2F,R30
; 0000 0067 TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
	OUT  0x2E,R30
; 0000 0068 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0069 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 006A ICR1H=0x00;
	OUT  0x27,R30
; 0000 006B ICR1L=0x00;
	OUT  0x26,R30
; 0000 006C OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 006D OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 006E OCR1BH=0x00;
	OUT  0x29,R30
; 0000 006F OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0070 OCR1CH=0x00;
	STS  121,R30
; 0000 0071 OCR1CL=0x00;
	STS  120,R30
; 0000 0072 TCCR2=(0<<WGM20) | (0<<COM21) | (0<<COM20) | (0<<WGM21) | (0<<CS22) | (0<<CS21) | (0<<CS20);
	OUT  0x25,R30
; 0000 0073 TCNT2=0x00;
	OUT  0x24,R30
; 0000 0074 OCR2=0x00;
	OUT  0x23,R30
; 0000 0075 TCCR3A=(0<<COM3A1) | (0<<COM3A0) | (0<<COM3B1) | (0<<COM3B0) | (0<<COM3C1) | (0<<COM3C0) | (0<<WGM31) | (0<<WGM30);
	STS  139,R30
; 0000 0076 TCCR3B=(0<<ICNC3) | (0<<ICES3) | (0<<WGM33) | (0<<WGM32) | (0<<CS32) | (0<<CS31) | (0<<CS30);
	STS  138,R30
; 0000 0077 TCNT3H=0x00;
	STS  137,R30
; 0000 0078 TCNT3L=0x00;
	STS  136,R30
; 0000 0079 ICR3H=0x00;
	STS  129,R30
; 0000 007A ICR3L=0x00;
	STS  128,R30
; 0000 007B OCR3AH=0x00;
	STS  135,R30
; 0000 007C OCR3AL=0x00;
	STS  134,R30
; 0000 007D OCR3BH=0x00;
	STS  133,R30
; 0000 007E OCR3BL=0x00;
	STS  132,R30
; 0000 007F OCR3CH=0x00;
	STS  131,R30
; 0000 0080 OCR3CL=0x00;
	STS  130,R30
; 0000 0081 TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<OCIE0) | (0<<TOIE0);
	OUT  0x37,R30
; 0000 0082 ETIMSK=(0<<TICIE3) | (0<<OCIE3A) | (0<<OCIE3B) | (0<<TOIE3) | (0<<OCIE3C) | (0<<OCIE1C);
	STS  125,R30
; 0000 0083 EICRA=(0<<ISC31) | (0<<ISC30) | (0<<ISC21) | (0<<ISC20) | (0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
	STS  106,R30
; 0000 0084 EICRB=(0<<ISC71) | (0<<ISC70) | (0<<ISC61) | (0<<ISC60) | (0<<ISC51) | (0<<ISC50) | (0<<ISC41) | (0<<ISC40);
	OUT  0x3A,R30
; 0000 0085 EIMSK=(0<<INT7) | (0<<INT6) | (0<<INT5) | (0<<INT4) | (0<<INT3) | (0<<INT2) | (0<<INT1) | (0<<INT0);
	OUT  0x39,R30
; 0000 0086 UCSR0A=(0<<RXC0) | (0<<TXC0) | (0<<UDRE0) | (0<<FE0) | (0<<DOR0) | (0<<UPE0) | (0<<U2X0) | (0<<MPCM0);
	OUT  0xB,R30
; 0000 0087 UCSR0B=(1<<RXCIE0) | (0<<TXCIE0) | (0<<UDRIE0) | (1<<RXEN0) | (1<<TXEN0) | (0<<UCSZ02) | (0<<RXB80) | (0<<TXB80);
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 0088 UCSR0C=(0<<UMSEL0) | (0<<UPM01) | (0<<UPM00) | (0<<USBS0) | (1<<UCSZ01) | (1<<UCSZ00) | (0<<UCPOL0);
	LDI  R30,LOW(6)
	STS  149,R30
; 0000 0089 UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
; 0000 008A UBRR0L=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
; 0000 008B UCSR1B=(0<<RXCIE1) | (0<<TXCIE1) | (0<<UDRIE1) | (0<<RXEN1) | (0<<TXEN1) | (0<<UCSZ12) | (0<<RXB81) | (0<<TXB81);
	LDI  R30,LOW(0)
	STS  154,R30
; 0000 008C ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 008D SFIOR=(0<<ACME);
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 008E ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
	OUT  0x6,R30
; 0000 008F SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
	OUT  0xD,R30
; 0000 0090 TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
	STS  116,R30
; 0000 0091 lcd_init(16);
	LDI  R26,LOW(16)
	CALL _lcd_init
; 0000 0092 #asm("sei")
	sei
; 0000 0093 
; 0000 0094 while (1)
_0x8:
; 0000 0095       {
; 0000 0096       if(PINC.0==1)
	SBIS 0x13,0
	RJMP _0xB
; 0000 0097       {
; 0000 0098       PORTE.4=1;
	SBI  0x3,4
; 0000 0099       putchar(0b00001001);
	LDI  R26,LOW(9)
	CALL _putchar
; 0000 009A       PORTE.4=0;
	CBI  0x3,4
; 0000 009B       //lcd_gotoxy(6,0);
; 0000 009C       //lcd_puts("");
; 0000 009D       while(PINC.0==1)
_0x10:
	SBIC 0x13,0
; 0000 009E       {;
; 0000 009F       };
	RJMP _0x10
; 0000 00A0       } ;
_0xB:
; 0000 00A1       if(PINC.1==1)
	SBIS 0x13,1
	RJMP _0x13
; 0000 00A2       {putchar(0b00001010);
	LDI  R26,LOW(10)
	CALL _putchar
; 0000 00A3       while(PINC.1==1)
_0x14:
	SBIC 0x13,1
; 0000 00A4       {;
; 0000 00A5       };
	RJMP _0x14
; 0000 00A6       };
_0x13:
; 0000 00A7        if(PINC.2==1)
	SBIS 0x13,2
	RJMP _0x17
; 0000 00A8       {putchar(0b10001000);
	LDI  R26,LOW(136)
	CALL _putchar
; 0000 00A9       while(PINC.2==1)
_0x18:
	SBIC 0x13,2
; 0000 00AA       {;
; 0000 00AB       };
	RJMP _0x18
; 0000 00AC       } ;
_0x17:
; 0000 00AD        if(PINC.3==1)
	SBIS 0x13,3
	RJMP _0x1B
; 0000 00AE       {putchar(0b00101000);
	LDI  R26,LOW(40)
	CALL _putchar
; 0000 00AF       while(PINC.3==1)
_0x1C:
	SBIC 0x13,3
; 0000 00B0       {;
; 0000 00B1       };
	RJMP _0x1C
; 0000 00B2       };
_0x1B:
; 0000 00B3       while(PINC.4==1)
_0x1F:
	SBIS 0x13,4
	RJMP _0x21
; 0000 00B4       {
; 0000 00B5       putchar(0b01010000);
	LDI  R26,LOW(80)
	CALL SUBOPT_0x0
; 0000 00B6       delay_ms(250);
; 0000 00B7       lcd_gotoxy(6,1); lcd_puts("R");
	__POINTW2MN _0x22,0
	CALL _lcd_puts
; 0000 00B8       };
	RJMP _0x1F
_0x21:
; 0000 00B9        while(PINC.5==1)
_0x23:
	SBIS 0x13,5
	RJMP _0x25
; 0000 00BA       {
; 0000 00BB       putchar(0b00010100);
	LDI  R26,LOW(20)
	CALL SUBOPT_0x0
; 0000 00BC       delay_ms(250);
; 0000 00BD       lcd_gotoxy(6,1); lcd_puts("L");
	__POINTW2MN _0x22,2
	CALL _lcd_puts
; 0000 00BE       };
	RJMP _0x23
_0x25:
; 0000 00BF       putchar(0b11000000);//0b11000000
	LDI  R26,LOW(192)
	CALL _putchar
; 0000 00C0       //lcd_clear();
; 0000 00C1       switch (data[0]) {
	LDS  R30,_data
	LDI  R31,0
; 0000 00C2     case 0b00000000:
	SBIW R30,0
	BRNE _0x29
; 0000 00C3     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00C4     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("__----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,4
	CALL _lcd_puts
; 0000 00C5 
; 0000 00C6     break;
	RJMP _0x28
; 0000 00C7     case 0b00000001:
_0x29:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2A
; 0000 00C8     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00C9     lcd_puts("ERR");lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,11
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,15
	CALL _lcd_puts
; 0000 00CA     break;
	RJMP _0x28
; 0000 00CB     case 0b00000010:
_0x2A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2B
; 0000 00CC      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00CD     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,23
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,27
	CALL _lcd_puts
; 0000 00CE     break;
	RJMP _0x28
; 0000 00CF     case 0b00000011:
_0x2B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2C
; 0000 00D0      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00D1     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,35
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,39
	CALL _lcd_puts
; 0000 00D2     break;
	RJMP _0x28
; 0000 00D3     case 0b00000100:
_0x2C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x2D
; 0000 00D4      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00D5     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,47
	CALL _lcd_puts
; 0000 00D6     break;
	RJMP _0x28
; 0000 00D7     case 0b00000101:
_0x2D:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x2E
; 0000 00D8     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00D9     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
	__POINTW2MN _0x22,55
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,59
	CALL _lcd_puts
; 0000 00DA     break;
	RJMP _0x28
; 0000 00DB     case 0b00000110:
_0x2E:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x2F
; 0000 00DC      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00DD     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
	__POINTW2MN _0x22,67
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,71
	CALL _lcd_puts
; 0000 00DE     break;
	RJMP _0x28
; 0000 00DF     case 0b00000111:
_0x2F:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x30
; 0000 00E0      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00E1     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
	__POINTW2MN _0x22,79
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,83
	CALL _lcd_puts
; 0000 00E2     break;
	RJMP _0x28
; 0000 00E3     case 0b00001000:
_0x30:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x31
; 0000 00E4     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00E5     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,91
	CALL _lcd_puts
; 0000 00E6     break;
	RJMP _0x28
; 0000 00E7     case  0b00001001:
_0x31:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x32
; 0000 00E8     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00E9     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
	__POINTW2MN _0x22,99
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,103
	CALL _lcd_puts
; 0000 00EA     break;
	RJMP _0x28
; 0000 00EB     case 0b00001010:
_0x32:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x33
; 0000 00EC      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00ED     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR");
	__POINTW2MN _0x22,111
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,115
	CALL _lcd_puts
; 0000 00EE     break;
	RJMP _0x28
; 0000 00EF     case 0b00001011:
_0x33:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x34
; 0000 00F0      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00F1     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR");
	__POINTW2MN _0x22,123
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,127
	CALL _lcd_puts
; 0000 00F2     break;
	RJMP _0x28
; 0000 00F3      case 0b00001100:
_0x34:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x35
; 0000 00F4     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00F5    /* lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,135
	CALL _lcd_puts
; 0000 00F6     break;
	RJMP _0x28
; 0000 00F7     case  0b00001101:
_0x35:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x36
; 0000 00F8     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00F9     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,143
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,147
	CALL _lcd_puts
; 0000 00FA     break;
	RJMP _0x28
; 0000 00FB     case 0b00001110:
_0x36:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0x37
; 0000 00FC      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 00FD     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,155
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,159
	CALL _lcd_puts
; 0000 00FE     break;
	RJMP _0x28
; 0000 00FF     case 0b00001111:
_0x37:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x38
; 0000 0100      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0101     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,167
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,171
	CALL _lcd_puts
; 0000 0102     break;
	RJMP _0x28
; 0000 0103     case 0b00010000:
_0x38:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x39
; 0000 0104     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0105     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,179
	CALL SUBOPT_0x4
; 0000 0106     lcd_gotoxy(8,1);
; 0000 0107     lcd_puts("_____RPM");
	__POINTW2MN _0x22,187
	CALL _lcd_puts
; 0000 0108     break;
	RJMP _0x28
; 0000 0109     case 0b00010001:
_0x39:
	CPI  R30,LOW(0x11)
	LDI  R26,HIGH(0x11)
	CPC  R31,R26
	BRNE _0x3A
; 0000 010A     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 010B     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,196
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,200
	CALL SUBOPT_0x4
; 0000 010C     lcd_gotoxy(8,1);
; 0000 010D     lcd_puts("_____RPM");
	__POINTW2MN _0x22,208
	CALL _lcd_puts
; 0000 010E     break;
	RJMP _0x28
; 0000 010F     case 0b00010010:
_0x3A:
	CPI  R30,LOW(0x12)
	LDI  R26,HIGH(0x12)
	CPC  R31,R26
	BRNE _0x3B
; 0000 0110      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0111     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,217
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,221
	CALL SUBOPT_0x4
; 0000 0112     lcd_gotoxy(8,1);
; 0000 0113     lcd_puts("_____RPM");
	__POINTW2MN _0x22,229
	CALL _lcd_puts
; 0000 0114     break;
	RJMP _0x28
; 0000 0115     case 0b00010011:
_0x3B:
	CPI  R30,LOW(0x13)
	LDI  R26,HIGH(0x13)
	CPC  R31,R26
	BRNE _0x3C
; 0000 0116      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0117     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,238
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,242
	CALL SUBOPT_0x4
; 0000 0118     lcd_gotoxy(8,1);
; 0000 0119     lcd_puts("_____RPM");
	__POINTW2MN _0x22,250
	CALL _lcd_puts
; 0000 011A     break;
	RJMP _0x28
; 0000 011B     case 0b00010100:
_0x3C:
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BRNE _0x3D
; 0000 011C      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 011D     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,259
	CALL SUBOPT_0x4
; 0000 011E     lcd_gotoxy(8,1);
; 0000 011F     lcd_puts("_____RPM");
	__POINTW2MN _0x22,267
	CALL _lcd_puts
; 0000 0120     break;
	RJMP _0x28
; 0000 0121     case 0b00010101:
_0x3D:
	CPI  R30,LOW(0x15)
	LDI  R26,HIGH(0x15)
	CPC  R31,R26
	BRNE _0x3E
; 0000 0122     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0123     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
	__POINTW2MN _0x22,276
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,280
	CALL SUBOPT_0x4
; 0000 0124     lcd_gotoxy(8,1);
; 0000 0125     lcd_puts("_____RPM");
	__POINTW2MN _0x22,288
	CALL _lcd_puts
; 0000 0126     break;
	RJMP _0x28
; 0000 0127     case 0b00010110:
_0x3E:
	CPI  R30,LOW(0x16)
	LDI  R26,HIGH(0x16)
	CPC  R31,R26
	BRNE _0x3F
; 0000 0128      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0129     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
	__POINTW2MN _0x22,297
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,301
	CALL SUBOPT_0x4
; 0000 012A     lcd_gotoxy(8,1);
; 0000 012B     lcd_puts("_____RPM");
	__POINTW2MN _0x22,309
	CALL _lcd_puts
; 0000 012C     break;
	RJMP _0x28
; 0000 012D     case 0b00010111:
_0x3F:
	CPI  R30,LOW(0x17)
	LDI  R26,HIGH(0x17)
	CPC  R31,R26
	BRNE _0x40
; 0000 012E 
; 0000 012F      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0130     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
	__POINTW2MN _0x22,318
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,322
	CALL SUBOPT_0x4
; 0000 0131     lcd_gotoxy(8,1);
; 0000 0132     lcd_puts("_____RPM");
	__POINTW2MN _0x22,330
	CALL _lcd_puts
; 0000 0133     break;
	RJMP _0x28
; 0000 0134     case 0b00011000:
_0x40:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x41
; 0000 0135     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0136     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,339
	CALL SUBOPT_0x4
; 0000 0137     lcd_gotoxy(8,1);
; 0000 0138     lcd_puts("_____RPM");
	__POINTW2MN _0x22,347
	CALL _lcd_puts
; 0000 0139     break;
	RJMP _0x28
; 0000 013A     case  0b00011001:
_0x41:
	CPI  R30,LOW(0x19)
	LDI  R26,HIGH(0x19)
	CPC  R31,R26
	BRNE _0x42
; 0000 013B     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 013C     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
	__POINTW2MN _0x22,356
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,360
	CALL SUBOPT_0x4
; 0000 013D     lcd_gotoxy(8,1);
; 0000 013E     lcd_puts("_____RPM");
	__POINTW2MN _0x22,368
	CALL _lcd_puts
; 0000 013F     break;
	RJMP _0x28
; 0000 0140     case 0b00011010:
_0x42:
	CPI  R30,LOW(0x1A)
	LDI  R26,HIGH(0x1A)
	CPC  R31,R26
	BRNE _0x43
; 0000 0141      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0142     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR");
	__POINTW2MN _0x22,377
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,381
	CALL SUBOPT_0x4
; 0000 0143     lcd_gotoxy(8,1);
; 0000 0144     lcd_puts("_____RPM");
	__POINTW2MN _0x22,389
	CALL _lcd_puts
; 0000 0145     break;
	RJMP _0x28
; 0000 0146     case 0b00011011:
_0x43:
	CPI  R30,LOW(0x1B)
	LDI  R26,HIGH(0x1B)
	CPC  R31,R26
	BRNE _0x44
; 0000 0147      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0148     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR");
	__POINTW2MN _0x22,398
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,402
	CALL SUBOPT_0x4
; 0000 0149       lcd_gotoxy(8,1);
; 0000 014A     lcd_puts("_____RPM");
	__POINTW2MN _0x22,410
	CALL _lcd_puts
; 0000 014B     break;
	RJMP _0x28
; 0000 014C      case 0b00011100:
_0x44:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x45
; 0000 014D     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 014E     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,419
	CALL SUBOPT_0x4
; 0000 014F       lcd_gotoxy(8,1);
; 0000 0150     lcd_puts("_____RPM");
	__POINTW2MN _0x22,427
	CALL _lcd_puts
; 0000 0151     break;
	RJMP _0x28
; 0000 0152     case  0b00011101:
_0x45:
	CPI  R30,LOW(0x1D)
	LDI  R26,HIGH(0x1D)
	CPC  R31,R26
	BRNE _0x46
; 0000 0153     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0154     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,436
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,440
	CALL SUBOPT_0x4
; 0000 0155       lcd_gotoxy(8,1);
; 0000 0156     lcd_puts("_____RPM");
	__POINTW2MN _0x22,448
	CALL _lcd_puts
; 0000 0157     break;
	RJMP _0x28
; 0000 0158     case 0b00011110:
_0x46:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x47
; 0000 0159      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 015A     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,457
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,461
	CALL SUBOPT_0x4
; 0000 015B       lcd_gotoxy(8,1);
; 0000 015C     lcd_puts("_____RPM");
	__POINTW2MN _0x22,469
	CALL _lcd_puts
; 0000 015D     break;
	RJMP _0x28
; 0000 015E     case 0b00011111:
_0x47:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x48
; 0000 015F      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0160     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,478
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,482
	CALL SUBOPT_0x4
; 0000 0161       lcd_gotoxy(8,1);
; 0000 0162     lcd_puts("_____RPM");
	__POINTW2MN _0x22,490
	CALL _lcd_puts
; 0000 0163     break;
	RJMP _0x28
; 0000 0164     case 0b00100000:
_0x48:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x49
; 0000 0165     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0166     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,499
	CALL SUBOPT_0x4
; 0000 0167     lcd_gotoxy(8,1);
; 0000 0168     lcd_puts("START___");
	__POINTW2MN _0x22,507
	CALL _lcd_puts
; 0000 0169     break;
	RJMP _0x28
; 0000 016A     case 0b00100001:
_0x49:
	CPI  R30,LOW(0x21)
	LDI  R26,HIGH(0x21)
	CPC  R31,R26
	BRNE _0x4A
; 0000 016B     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 016C     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,516
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,520
	CALL SUBOPT_0x4
; 0000 016D     lcd_gotoxy(8,1);
; 0000 016E     lcd_puts("START___");
	__POINTW2MN _0x22,528
	CALL _lcd_puts
; 0000 016F     break;
	RJMP _0x28
; 0000 0170     case 0b00100010:
_0x4A:
	CPI  R30,LOW(0x22)
	LDI  R26,HIGH(0x22)
	CPC  R31,R26
	BRNE _0x4B
; 0000 0171      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0172     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,537
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,541
	CALL SUBOPT_0x4
; 0000 0173     lcd_gotoxy(8,1);
; 0000 0174     lcd_puts("START___");
	__POINTW2MN _0x22,549
	CALL _lcd_puts
; 0000 0175     break;
	RJMP _0x28
; 0000 0176     case 0b00100011:
_0x4B:
	CPI  R30,LOW(0x23)
	LDI  R26,HIGH(0x23)
	CPC  R31,R26
	BRNE _0x4C
; 0000 0177      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0178     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,558
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,562
	CALL SUBOPT_0x4
; 0000 0179     lcd_gotoxy(8,1);
; 0000 017A     lcd_puts("START___");
	__POINTW2MN _0x22,570
	CALL _lcd_puts
; 0000 017B     break;
	RJMP _0x28
; 0000 017C     case 0b00100100:
_0x4C:
	CPI  R30,LOW(0x24)
	LDI  R26,HIGH(0x24)
	CPC  R31,R26
	BRNE _0x4D
; 0000 017D      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 017E     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,579
	CALL SUBOPT_0x4
; 0000 017F     lcd_gotoxy(8,1);
; 0000 0180     lcd_puts("START___");
	__POINTW2MN _0x22,587
	CALL _lcd_puts
; 0000 0181     break;
	RJMP _0x28
; 0000 0182     case 0b00100101:
_0x4D:
	CPI  R30,LOW(0x25)
	LDI  R26,HIGH(0x25)
	CPC  R31,R26
	BRNE _0x4E
; 0000 0183     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0184     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
	__POINTW2MN _0x22,596
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,600
	CALL SUBOPT_0x4
; 0000 0185     lcd_gotoxy(8,1);
; 0000 0186     lcd_puts("START___");
	__POINTW2MN _0x22,608
	CALL _lcd_puts
; 0000 0187     break;
	RJMP _0x28
; 0000 0188     case 0b00100110:
_0x4E:
	CPI  R30,LOW(0x26)
	LDI  R26,HIGH(0x26)
	CPC  R31,R26
	BRNE _0x4F
; 0000 0189      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 018A     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
	__POINTW2MN _0x22,617
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,621
	CALL SUBOPT_0x4
; 0000 018B     lcd_gotoxy(8,1);
; 0000 018C     lcd_puts("START___");
	__POINTW2MN _0x22,629
	CALL _lcd_puts
; 0000 018D     break;
	RJMP _0x28
; 0000 018E     case 0b00100111:
_0x4F:
	CPI  R30,LOW(0x27)
	LDI  R26,HIGH(0x27)
	CPC  R31,R26
	BRNE _0x50
; 0000 018F 
; 0000 0190      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0191     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
	__POINTW2MN _0x22,638
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,642
	CALL SUBOPT_0x4
; 0000 0192     lcd_gotoxy(8,1);
; 0000 0193     lcd_puts("START___");
	__POINTW2MN _0x22,650
	CALL _lcd_puts
; 0000 0194     break;
	RJMP _0x28
; 0000 0195     case 0b00101000:
_0x50:
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x51
; 0000 0196     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0197     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,659
	CALL SUBOPT_0x4
; 0000 0198     lcd_gotoxy(8,1);
; 0000 0199     lcd_puts("START___");
	__POINTW2MN _0x22,667
	CALL _lcd_puts
; 0000 019A     break;
	RJMP _0x28
; 0000 019B     case  0b00101001:
_0x51:
	CPI  R30,LOW(0x29)
	LDI  R26,HIGH(0x29)
	CPC  R31,R26
	BRNE _0x52
; 0000 019C     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 019D     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
	__POINTW2MN _0x22,676
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,680
	CALL SUBOPT_0x4
; 0000 019E     lcd_gotoxy(8,1);
; 0000 019F     lcd_puts("START___");
	__POINTW2MN _0x22,688
	CALL _lcd_puts
; 0000 01A0     break;
	RJMP _0x28
; 0000 01A1     case 0b00101010:
_0x52:
	CPI  R30,LOW(0x2A)
	LDI  R26,HIGH(0x2A)
	CPC  R31,R26
	BRNE _0x53
; 0000 01A2      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01A3     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR");
	__POINTW2MN _0x22,697
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,701
	CALL SUBOPT_0x4
; 0000 01A4     lcd_gotoxy(8,1);
; 0000 01A5     lcd_puts("START___");
	__POINTW2MN _0x22,709
	CALL _lcd_puts
; 0000 01A6     break;
	RJMP _0x28
; 0000 01A7     case 0b00101011:
_0x53:
	CPI  R30,LOW(0x2B)
	LDI  R26,HIGH(0x2B)
	CPC  R31,R26
	BRNE _0x54
; 0000 01A8      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01A9     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR");
	__POINTW2MN _0x22,718
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,722
	CALL SUBOPT_0x4
; 0000 01AA       lcd_gotoxy(8,1);
; 0000 01AB     lcd_puts("START___");
	__POINTW2MN _0x22,730
	CALL _lcd_puts
; 0000 01AC     break;
	RJMP _0x28
; 0000 01AD      case 0b00101100:
_0x54:
	CPI  R30,LOW(0x2C)
	LDI  R26,HIGH(0x2C)
	CPC  R31,R26
	BRNE _0x55
; 0000 01AE     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01AF     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,739
	CALL SUBOPT_0x4
; 0000 01B0       lcd_gotoxy(8,1);
; 0000 01B1     lcd_puts("START___");
	__POINTW2MN _0x22,747
	CALL _lcd_puts
; 0000 01B2     break;
	RJMP _0x28
; 0000 01B3     case  0b00101101:
_0x55:
	CPI  R30,LOW(0x2D)
	LDI  R26,HIGH(0x2D)
	CPC  R31,R26
	BRNE _0x56
; 0000 01B4     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01B5     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,756
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,760
	CALL SUBOPT_0x4
; 0000 01B6       lcd_gotoxy(8,1);
; 0000 01B7     lcd_puts("START___");
	__POINTW2MN _0x22,768
	CALL _lcd_puts
; 0000 01B8     break;
	RJMP _0x28
; 0000 01B9     case 0b00101110:
_0x56:
	CPI  R30,LOW(0x2E)
	LDI  R26,HIGH(0x2E)
	CPC  R31,R26
	BRNE _0x57
; 0000 01BA      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01BB     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,777
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,781
	CALL SUBOPT_0x4
; 0000 01BC       lcd_gotoxy(8,1);
; 0000 01BD     lcd_puts("START___");
	__POINTW2MN _0x22,789
	CALL _lcd_puts
; 0000 01BE     break;
	RJMP _0x28
; 0000 01BF     case 0b00101111:
_0x57:
	CPI  R30,LOW(0x2F)
	LDI  R26,HIGH(0x2F)
	CPC  R31,R26
	BRNE _0x58
; 0000 01C0      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01C1     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,798
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,802
	CALL SUBOPT_0x4
; 0000 01C2       lcd_gotoxy(8,1);
; 0000 01C3     lcd_puts("START___");
	__POINTW2MN _0x22,810
	CALL _lcd_puts
; 0000 01C4     break;
	RJMP _0x28
; 0000 01C5 case 0b00110000:
_0x58:
	CPI  R30,LOW(0x30)
	LDI  R26,HIGH(0x30)
	CPC  R31,R26
	BRNE _0x59
; 0000 01C6     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01C7     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,819
	CALL SUBOPT_0x4
; 0000 01C8     lcd_gotoxy(8,1);
; 0000 01C9     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,827
	CALL _lcd_puts
; 0000 01CA     break;
	RJMP _0x28
; 0000 01CB     case 0b00110001:
_0x59:
	CPI  R30,LOW(0x31)
	LDI  R26,HIGH(0x31)
	CPC  R31,R26
	BRNE _0x5A
; 0000 01CC     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01CD     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,836
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,840
	CALL SUBOPT_0x4
; 0000 01CE     lcd_gotoxy(8,1);
; 0000 01CF     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,848
	CALL _lcd_puts
; 0000 01D0     break;
	RJMP _0x28
; 0000 01D1     case 0b00110010:
_0x5A:
	CPI  R30,LOW(0x32)
	LDI  R26,HIGH(0x32)
	CPC  R31,R26
	BRNE _0x5B
; 0000 01D2      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01D3     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,857
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,861
	CALL SUBOPT_0x4
; 0000 01D4     lcd_gotoxy(8,1);
; 0000 01D5     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,869
	CALL _lcd_puts
; 0000 01D6     break;
	RJMP _0x28
; 0000 01D7     case 0b00110011:
_0x5B:
	CPI  R30,LOW(0x33)
	LDI  R26,HIGH(0x33)
	CPC  R31,R26
	BRNE _0x5C
; 0000 01D8      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01D9     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,878
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,882
	CALL SUBOPT_0x4
; 0000 01DA     lcd_gotoxy(8,1);
; 0000 01DB     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,890
	CALL _lcd_puts
; 0000 01DC     break;
	RJMP _0x28
; 0000 01DD     case 0b00110100:
_0x5C:
	CPI  R30,LOW(0x34)
	LDI  R26,HIGH(0x34)
	CPC  R31,R26
	BRNE _0x5D
; 0000 01DE      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01DF     /*lcd_puts("_");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,899
	CALL SUBOPT_0x4
; 0000 01E0     lcd_gotoxy(8,1);
; 0000 01E1     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,907
	CALL _lcd_puts
; 0000 01E2     break;
	RJMP _0x28
; 0000 01E3     case 0b00110101:
_0x5D:
	CPI  R30,LOW(0x35)
	LDI  R26,HIGH(0x35)
	CPC  R31,R26
	BRNE _0x5E
; 0000 01E4     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01E5     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
	__POINTW2MN _0x22,916
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,920
	CALL SUBOPT_0x4
; 0000 01E6     lcd_gotoxy(8,1);
; 0000 01E7     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,928
	CALL _lcd_puts
; 0000 01E8     break;
	RJMP _0x28
; 0000 01E9     case 0b00110110:
_0x5E:
	CPI  R30,LOW(0x36)
	LDI  R26,HIGH(0x36)
	CPC  R31,R26
	BRNE _0x5F
; 0000 01EA      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01EB     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
	__POINTW2MN _0x22,937
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,941
	CALL SUBOPT_0x4
; 0000 01EC     lcd_gotoxy(8,1);
; 0000 01ED     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,949
	CALL _lcd_puts
; 0000 01EE     break;
	RJMP _0x28
; 0000 01EF     case 0b00110111:
_0x5F:
	CPI  R30,LOW(0x37)
	LDI  R26,HIGH(0x37)
	CPC  R31,R26
	BRNE _0x60
; 0000 01F0 
; 0000 01F1      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01F2     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
	__POINTW2MN _0x22,958
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,962
	CALL SUBOPT_0x4
; 0000 01F3     lcd_gotoxy(8,1);
; 0000 01F4     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,970
	CALL _lcd_puts
; 0000 01F5     break;
	RJMP _0x28
; 0000 01F6     case 0b00111000:
_0x60:
	CPI  R30,LOW(0x38)
	LDI  R26,HIGH(0x38)
	CPC  R31,R26
	BRNE _0x61
; 0000 01F7     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01F8     /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,979
	CALL SUBOPT_0x4
; 0000 01F9     lcd_gotoxy(8,1);
; 0000 01FA     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,987
	CALL _lcd_puts
; 0000 01FB     break;
	RJMP _0x28
; 0000 01FC     case  0b00111001:
_0x61:
	CPI  R30,LOW(0x39)
	LDI  R26,HIGH(0x39)
	CPC  R31,R26
	BRNE _0x62
; 0000 01FD     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 01FE     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
	__POINTW2MN _0x22,996
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,1000
	CALL SUBOPT_0x4
; 0000 01FF     lcd_gotoxy(8,1);
; 0000 0200     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,1008
	CALL _lcd_puts
; 0000 0201     break;
	RJMP _0x28
; 0000 0202     case 0b00111010:
_0x62:
	CPI  R30,LOW(0x3A)
	LDI  R26,HIGH(0x3A)
	CPC  R31,R26
	BRNE _0x63
; 0000 0203      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0204     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR");
	__POINTW2MN _0x22,1017
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,1021
	CALL SUBOPT_0x4
; 0000 0205     lcd_gotoxy(8,1);
; 0000 0206     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,1029
	CALL _lcd_puts
; 0000 0207     break;
	RJMP _0x28
; 0000 0208     case 0b00111011:
_0x63:
	CPI  R30,LOW(0x3B)
	LDI  R26,HIGH(0x3B)
	CPC  R31,R26
	BRNE _0x64
; 0000 0209      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 020A     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR");
	__POINTW2MN _0x22,1038
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,1042
	CALL SUBOPT_0x4
; 0000 020B       lcd_gotoxy(8,1);
; 0000 020C     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,1050
	CALL _lcd_puts
; 0000 020D     break;
	RJMP _0x28
; 0000 020E      case 0b00111100:
_0x64:
	CPI  R30,LOW(0x3C)
	LDI  R26,HIGH(0x3C)
	CPC  R31,R26
	BRNE _0x65
; 0000 020F     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0210     /*lcd_puts("___"); */lcd_gotoxy(9,0);lcd_puts("___----");
	CALL SUBOPT_0x2
	__POINTW2MN _0x22,1059
	CALL SUBOPT_0x4
; 0000 0211       lcd_gotoxy(8,1);
; 0000 0212     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,1067
	CALL _lcd_puts
; 0000 0213     break;
	RJMP _0x28
; 0000 0214     case  0b00111101:
_0x65:
	CPI  R30,LOW(0x3D)
	LDI  R26,HIGH(0x3D)
	CPC  R31,R26
	BRNE _0x66
; 0000 0215     lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0216     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
	__POINTW2MN _0x22,1076
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,1080
	CALL SUBOPT_0x4
; 0000 0217       lcd_gotoxy(8,1);
; 0000 0218     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,1088
	CALL _lcd_puts
; 0000 0219     break;
	RJMP _0x28
; 0000 021A     case 0b00111110:
_0x66:
	CPI  R30,LOW(0x3E)
	LDI  R26,HIGH(0x3E)
	CPC  R31,R26
	BRNE _0x67
; 0000 021B      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 021C     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
	__POINTW2MN _0x22,1097
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,1101
	CALL SUBOPT_0x4
; 0000 021D       lcd_gotoxy(8,1);
; 0000 021E     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,1109
	CALL _lcd_puts
; 0000 021F     break;
	RJMP _0x28
; 0000 0220     case 0b00111111:
_0x67:
	CPI  R30,LOW(0x3F)
	LDI  R26,HIGH(0x3F)
	CPC  R31,R26
	BRNE _0x69
; 0000 0221      lcd_gotoxy(0,0);
	CALL SUBOPT_0x1
; 0000 0222     lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
	__POINTW2MN _0x22,1118
	CALL SUBOPT_0x3
	__POINTW2MN _0x22,1122
	CALL SUBOPT_0x4
; 0000 0223       lcd_gotoxy(8,1);
; 0000 0224     lcd_puts("STARTRPM");
	__POINTW2MN _0x22,1130
	CALL _lcd_puts
; 0000 0225     break;
	RJMP _0x28
; 0000 0226     default:
_0x69:
; 0000 0227     lcd_gotoxy(12,1);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x5
; 0000 0228     //lcd_puts("fail");
; 0000 0229 
; 0000 022A     };
_0x28:
; 0000 022B     putchar(0b00101010);//0b00101010
	LDI  R26,LOW(42)
	RCALL _putchar
; 0000 022C     switch(data[0]){
	LDS  R30,_data
	LDI  R31,0
; 0000 022D     case 0b01000000: lcd_gotoxy(3,0);lcd_puts("______");break;
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x6D
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
	__POINTW2MN _0x22,1139
	CALL _lcd_puts
	RJMP _0x6C
; 0000 022E     case 0b01000001: lcd_gotoxy(0,0);lcd_puts("ERR_____p");break;
_0x6D:
	CPI  R30,LOW(0x41)
	LDI  R26,HIGH(0x41)
	CPC  R31,R26
	BRNE _0x6E
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1146
	CALL _lcd_puts
	RJMP _0x6C
; 0000 022F     case 0b01000010: lcd_gotoxy(0,0);lcd_puts("ERR____P_");break;
_0x6E:
	CPI  R30,LOW(0x42)
	LDI  R26,HIGH(0x42)
	CPC  R31,R26
	BRNE _0x6F
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1156
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0230     case 0b01000011: lcd_gotoxy(0,0);lcd_puts("ERR____Pp");break;
_0x6F:
	CPI  R30,LOW(0x43)
	LDI  R26,HIGH(0x43)
	CPC  R31,R26
	BRNE _0x70
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1166
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0231     case 0b01000100: lcd_gotoxy(0,0);lcd_puts("ERR___4__");break;
_0x70:
	CPI  R30,LOW(0x44)
	LDI  R26,HIGH(0x44)
	CPC  R31,R26
	BRNE _0x71
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1176
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0232     case 0b01000101: lcd_gotoxy(0,0);lcd_puts("ERR___4_p");break;
_0x71:
	CPI  R30,LOW(0x45)
	LDI  R26,HIGH(0x45)
	CPC  R31,R26
	BRNE _0x72
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1186
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0233     case 0b01000110: lcd_gotoxy(0,0);lcd_puts("ERR___4P_");break;
_0x72:
	CPI  R30,LOW(0x46)
	LDI  R26,HIGH(0x46)
	CPC  R31,R26
	BRNE _0x73
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1196
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0234     case 0b01000111: lcd_gotoxy(0,0);lcd_puts("ERR___4_p");break;
_0x73:
	CPI  R30,LOW(0x47)
	LDI  R26,HIGH(0x47)
	CPC  R31,R26
	BRNE _0x74
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1206
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0235     case 0b01001000: lcd_gotoxy(0,0);lcd_puts("ERR__3___");break;
_0x74:
	CPI  R30,LOW(0x48)
	LDI  R26,HIGH(0x48)
	CPC  R31,R26
	BRNE _0x75
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1216
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0236     case 0b01001001: lcd_gotoxy(0,0);lcd_puts("ERR__3__p");break;
_0x75:
	CPI  R30,LOW(0x49)
	LDI  R26,HIGH(0x49)
	CPC  R31,R26
	BRNE _0x76
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1226
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0237     case 0b01001010: lcd_gotoxy(0,0);lcd_puts("ERR__3_P_");break;
_0x76:
	CPI  R30,LOW(0x4A)
	LDI  R26,HIGH(0x4A)
	CPC  R31,R26
	BRNE _0x77
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1236
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0238     case 0b01001011: lcd_gotoxy(0,0);lcd_puts("ERR__3_Pp");break;
_0x77:
	CPI  R30,LOW(0x4B)
	LDI  R26,HIGH(0x4B)
	CPC  R31,R26
	BRNE _0x78
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1246
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0239     case 0b01001100: lcd_gotoxy(0,0);lcd_puts("ERR__34__");break;
_0x78:
	CPI  R30,LOW(0x4C)
	LDI  R26,HIGH(0x4C)
	CPC  R31,R26
	BRNE _0x79
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1256
	CALL _lcd_puts
	RJMP _0x6C
; 0000 023A     case 0b01001101: lcd_gotoxy(0,0);lcd_puts("ERR__34_p");break;
_0x79:
	CPI  R30,LOW(0x4D)
	LDI  R26,HIGH(0x4D)
	CPC  R31,R26
	BRNE _0x7A
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1266
	CALL _lcd_puts
	RJMP _0x6C
; 0000 023B     case 0b01001110: lcd_gotoxy(0,0);lcd_puts("ERR__34P_");break;
_0x7A:
	CPI  R30,LOW(0x4E)
	LDI  R26,HIGH(0x4E)
	CPC  R31,R26
	BRNE _0x7B
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1276
	CALL _lcd_puts
	RJMP _0x6C
; 0000 023C     case 0b01001111: lcd_gotoxy(0,0);lcd_puts("ERR__34Pp");break;
_0x7B:
	CPI  R30,LOW(0x4F)
	LDI  R26,HIGH(0x4F)
	CPC  R31,R26
	BRNE _0x7C
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1286
	CALL _lcd_puts
	RJMP _0x6C
; 0000 023D     case 0b01010000: lcd_gotoxy(0,0);lcd_puts("ERR_2____");break;
_0x7C:
	CPI  R30,LOW(0x50)
	LDI  R26,HIGH(0x50)
	CPC  R31,R26
	BRNE _0x7D
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1296
	CALL _lcd_puts
	RJMP _0x6C
; 0000 023E     case 0b01010001: lcd_gotoxy(0,0);lcd_puts("ERR_2___p");break;
_0x7D:
	CPI  R30,LOW(0x51)
	LDI  R26,HIGH(0x51)
	CPC  R31,R26
	BRNE _0x7E
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1306
	CALL _lcd_puts
	RJMP _0x6C
; 0000 023F     case 0b01010010: lcd_gotoxy(0,0);lcd_puts("ERR_2__P_");break;
_0x7E:
	CPI  R30,LOW(0x52)
	LDI  R26,HIGH(0x52)
	CPC  R31,R26
	BRNE _0x7F
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1316
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0240     case 0b01010011: lcd_gotoxy(0,0);lcd_puts("ERR_2__Pp");break;
_0x7F:
	CPI  R30,LOW(0x53)
	LDI  R26,HIGH(0x53)
	CPC  R31,R26
	BRNE _0x80
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1326
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0241     case 0b01010100: lcd_gotoxy(0,0);lcd_puts("ERR_2_4__");break;
_0x80:
	CPI  R30,LOW(0x54)
	LDI  R26,HIGH(0x54)
	CPC  R31,R26
	BRNE _0x81
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1336
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0242     case 0b01010101: lcd_gotoxy(0,0);lcd_puts("ERR_2_4_p");break;
_0x81:
	CPI  R30,LOW(0x55)
	LDI  R26,HIGH(0x55)
	CPC  R31,R26
	BRNE _0x82
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1346
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0243     case 0b01010110: lcd_gotoxy(0,0);lcd_puts("ERR_2_4P_");break;
_0x82:
	CPI  R30,LOW(0x56)
	LDI  R26,HIGH(0x56)
	CPC  R31,R26
	BRNE _0x83
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1356
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0244     case 0b01010111: lcd_gotoxy(0,0);lcd_puts("ERR_2_4Pp");break;
_0x83:
	CPI  R30,LOW(0x57)
	LDI  R26,HIGH(0x57)
	CPC  R31,R26
	BRNE _0x84
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1366
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0245     case 0b01011000: lcd_gotoxy(0,0);lcd_puts("ERR_23___");break;
_0x84:
	CPI  R30,LOW(0x58)
	LDI  R26,HIGH(0x58)
	CPC  R31,R26
	BRNE _0x85
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1376
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0246     case 0b01011001: lcd_gotoxy(0,0);lcd_puts("ERR_23__p");break;
_0x85:
	CPI  R30,LOW(0x59)
	LDI  R26,HIGH(0x59)
	CPC  R31,R26
	BRNE _0x86
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1386
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0247     case 0b01011010: lcd_gotoxy(0,0);lcd_puts("ERR_23_P_");break;
_0x86:
	CPI  R30,LOW(0x5A)
	LDI  R26,HIGH(0x5A)
	CPC  R31,R26
	BRNE _0x87
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1396
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0248     case 0b01011011: lcd_gotoxy(0,0);lcd_puts("ERR_23_Pp");break;
_0x87:
	CPI  R30,LOW(0x5B)
	LDI  R26,HIGH(0x5B)
	CPC  R31,R26
	BRNE _0x88
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1406
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0249     case 0b01011100: lcd_gotoxy(0,0);lcd_puts("ERR_234__");break;
_0x88:
	CPI  R30,LOW(0x5C)
	LDI  R26,HIGH(0x5C)
	CPC  R31,R26
	BRNE _0x89
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1416
	CALL _lcd_puts
	RJMP _0x6C
; 0000 024A     case 0b01011101: lcd_gotoxy(0,0);lcd_puts("ERR_234_p");break;
_0x89:
	CPI  R30,LOW(0x5D)
	LDI  R26,HIGH(0x5D)
	CPC  R31,R26
	BRNE _0x8A
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1426
	CALL _lcd_puts
	RJMP _0x6C
; 0000 024B     case 0b01011110: lcd_gotoxy(0,0);lcd_puts("ERR_234P_");break;
_0x8A:
	CPI  R30,LOW(0x5E)
	LDI  R26,HIGH(0x5E)
	CPC  R31,R26
	BRNE _0x8B
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1436
	CALL _lcd_puts
	RJMP _0x6C
; 0000 024C     case 0b01011111: lcd_gotoxy(0,0);lcd_puts("ERR_234Pp");break;
_0x8B:
	CPI  R30,LOW(0x5F)
	LDI  R26,HIGH(0x5F)
	CPC  R31,R26
	BRNE _0x8C
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1446
	CALL _lcd_puts
	RJMP _0x6C
; 0000 024D     case 0b01100000: lcd_gotoxy(0,0);lcd_puts("ERR1_____");break;
_0x8C:
	CPI  R30,LOW(0x60)
	LDI  R26,HIGH(0x60)
	CPC  R31,R26
	BRNE _0x8D
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1456
	CALL _lcd_puts
	RJMP _0x6C
; 0000 024E     case 0b01100001: lcd_gotoxy(0,0);lcd_puts("ERR1____p");break;
_0x8D:
	CPI  R30,LOW(0x61)
	LDI  R26,HIGH(0x61)
	CPC  R31,R26
	BRNE _0x8E
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1466
	CALL _lcd_puts
	RJMP _0x6C
; 0000 024F     case 0b01100010: lcd_gotoxy(0,0);lcd_puts("ERR1___P_");break;
_0x8E:
	CPI  R30,LOW(0x62)
	LDI  R26,HIGH(0x62)
	CPC  R31,R26
	BRNE _0x8F
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1476
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0250     case 0b01100011: lcd_gotoxy(0,0);lcd_puts("ERR1___Pp");break;
_0x8F:
	CPI  R30,LOW(0x63)
	LDI  R26,HIGH(0x63)
	CPC  R31,R26
	BRNE _0x90
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1486
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0251     case 0b01100100: lcd_gotoxy(0,0);lcd_puts("ERR1__4__");break;
_0x90:
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRNE _0x91
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1496
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0252     case 0b01100101: lcd_gotoxy(0,0);lcd_puts("ERR1__4_p");break;
_0x91:
	CPI  R30,LOW(0x65)
	LDI  R26,HIGH(0x65)
	CPC  R31,R26
	BRNE _0x92
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1506
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0253     case 0b01100110: lcd_gotoxy(0,0);lcd_puts("ERR1__4P_");break;
_0x92:
	CPI  R30,LOW(0x66)
	LDI  R26,HIGH(0x66)
	CPC  R31,R26
	BRNE _0x93
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1516
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0254     case 0b01100111: lcd_gotoxy(0,0);lcd_puts("ERR1__4Pp");break;
_0x93:
	CPI  R30,LOW(0x67)
	LDI  R26,HIGH(0x67)
	CPC  R31,R26
	BRNE _0x94
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1526
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0255     case 0b01101000: lcd_gotoxy(0,0);lcd_puts("ERR1_3___");break;
_0x94:
	CPI  R30,LOW(0x68)
	LDI  R26,HIGH(0x68)
	CPC  R31,R26
	BRNE _0x95
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1536
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0256     case 0b01101001: lcd_gotoxy(0,0);lcd_puts("ERR1_3__p");break;
_0x95:
	CPI  R30,LOW(0x69)
	LDI  R26,HIGH(0x69)
	CPC  R31,R26
	BRNE _0x96
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1546
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0257     case 0b01101010: lcd_gotoxy(0,0);lcd_puts("ERR1_3_P_");break;
_0x96:
	CPI  R30,LOW(0x6A)
	LDI  R26,HIGH(0x6A)
	CPC  R31,R26
	BRNE _0x97
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1556
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0258     case 0b01101011: lcd_gotoxy(0,0);lcd_puts("ERR1_3_Pp");break;
_0x97:
	CPI  R30,LOW(0x6B)
	LDI  R26,HIGH(0x6B)
	CPC  R31,R26
	BRNE _0x98
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1566
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0259     case 0b01101100: lcd_gotoxy(0,0);lcd_puts("ERR1_34__");break;
_0x98:
	CPI  R30,LOW(0x6C)
	LDI  R26,HIGH(0x6C)
	CPC  R31,R26
	BRNE _0x99
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1576
	CALL _lcd_puts
	RJMP _0x6C
; 0000 025A     case 0b01101101: lcd_gotoxy(0,0);lcd_puts("ERR1_34_p");break;
_0x99:
	CPI  R30,LOW(0x6D)
	LDI  R26,HIGH(0x6D)
	CPC  R31,R26
	BRNE _0x9A
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1586
	CALL _lcd_puts
	RJMP _0x6C
; 0000 025B     case 0b01101110: lcd_gotoxy(0,0);lcd_puts("ERR1_34P_");break;
_0x9A:
	CPI  R30,LOW(0x6E)
	LDI  R26,HIGH(0x6E)
	CPC  R31,R26
	BRNE _0x9B
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1596
	CALL _lcd_puts
	RJMP _0x6C
; 0000 025C     case 0b01101111: lcd_gotoxy(0,0);lcd_puts("ERR1_34Pp");break;
_0x9B:
	CPI  R30,LOW(0x6F)
	LDI  R26,HIGH(0x6F)
	CPC  R31,R26
	BRNE _0x9C
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1606
	CALL _lcd_puts
	RJMP _0x6C
; 0000 025D     case 0b01110000: lcd_gotoxy(0,0);lcd_puts("ERR12____");break;
_0x9C:
	CPI  R30,LOW(0x70)
	LDI  R26,HIGH(0x70)
	CPC  R31,R26
	BRNE _0x9D
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1616
	CALL _lcd_puts
	RJMP _0x6C
; 0000 025E     case 0b01110001: lcd_gotoxy(0,0);lcd_puts("ERR12___p");break;
_0x9D:
	CPI  R30,LOW(0x71)
	LDI  R26,HIGH(0x71)
	CPC  R31,R26
	BRNE _0x9E
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1626
	CALL _lcd_puts
	RJMP _0x6C
; 0000 025F     case 0b01110010: lcd_gotoxy(0,0);lcd_puts("ERR12__P_");break;
_0x9E:
	CPI  R30,LOW(0x72)
	LDI  R26,HIGH(0x72)
	CPC  R31,R26
	BRNE _0x9F
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1636
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0260     case 0b01110011: lcd_gotoxy(0,0);lcd_puts("ERR12__Pp");break;
_0x9F:
	CPI  R30,LOW(0x73)
	LDI  R26,HIGH(0x73)
	CPC  R31,R26
	BRNE _0xA0
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1646
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0261     case 0b01110100: lcd_gotoxy(0,0);lcd_puts("ERR12_4__");break;
_0xA0:
	CPI  R30,LOW(0x74)
	LDI  R26,HIGH(0x74)
	CPC  R31,R26
	BRNE _0xA1
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1656
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0262     case 0b01110101: lcd_gotoxy(0,0);lcd_puts("ERR12_4_p");break;
_0xA1:
	CPI  R30,LOW(0x75)
	LDI  R26,HIGH(0x75)
	CPC  R31,R26
	BRNE _0xA2
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1666
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0263     case 0b01110110: lcd_gotoxy(0,0);lcd_puts("ERR12_4P_");break;
_0xA2:
	CPI  R30,LOW(0x76)
	LDI  R26,HIGH(0x76)
	CPC  R31,R26
	BRNE _0xA3
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1676
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0264     case 0b01110111: lcd_gotoxy(0,0);lcd_puts("ERR12_4Pp");break;
_0xA3:
	CPI  R30,LOW(0x77)
	LDI  R26,HIGH(0x77)
	CPC  R31,R26
	BRNE _0xA4
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1686
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0265     case 0b01111000: lcd_gotoxy(0,0);lcd_puts("ERR123___");break;
_0xA4:
	CPI  R30,LOW(0x78)
	LDI  R26,HIGH(0x78)
	CPC  R31,R26
	BRNE _0xA5
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1696
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0266     case 0b01111001: lcd_gotoxy(0,0);lcd_puts("ERR123__p");break;
_0xA5:
	CPI  R30,LOW(0x79)
	LDI  R26,HIGH(0x79)
	CPC  R31,R26
	BRNE _0xA6
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1706
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0267     case 0b01111010: lcd_gotoxy(0,0);lcd_puts("ERR123_P_");break;
_0xA6:
	CPI  R30,LOW(0x7A)
	LDI  R26,HIGH(0x7A)
	CPC  R31,R26
	BRNE _0xA7
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1716
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0268     case 0b01111011: lcd_gotoxy(0,0);lcd_puts("ERR123_Pp");break;
_0xA7:
	CPI  R30,LOW(0x7B)
	LDI  R26,HIGH(0x7B)
	CPC  R31,R26
	BRNE _0xA8
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1726
	CALL _lcd_puts
	RJMP _0x6C
; 0000 0269     case 0b01111100: lcd_gotoxy(0,0);lcd_puts("ERR1234__");break;
_0xA8:
	CPI  R30,LOW(0x7C)
	LDI  R26,HIGH(0x7C)
	CPC  R31,R26
	BRNE _0xA9
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1736
	CALL _lcd_puts
	RJMP _0x6C
; 0000 026A     case 0b01111101: lcd_gotoxy(0,0);lcd_puts("ERR1234_p");break;
_0xA9:
	CPI  R30,LOW(0x7D)
	LDI  R26,HIGH(0x7D)
	CPC  R31,R26
	BRNE _0xAA
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1746
	CALL _lcd_puts
	RJMP _0x6C
; 0000 026B     case 0b01111110: lcd_gotoxy(0,0);lcd_puts("ERR1234P_");break;
_0xAA:
	CPI  R30,LOW(0x7E)
	LDI  R26,HIGH(0x7E)
	CPC  R31,R26
	BRNE _0xAB
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1756
	CALL _lcd_puts
	RJMP _0x6C
; 0000 026C     case 0b01111111: lcd_gotoxy(0,0);lcd_puts("ERR1234Pp");break;
_0xAB:
	CPI  R30,LOW(0x7F)
	LDI  R26,HIGH(0x7F)
	CPC  R31,R26
	BRNE _0xAD
	CALL SUBOPT_0x1
	__POINTW2MN _0x22,1766
	CALL _lcd_puts
	RJMP _0x6C
; 0000 026D     default: lcd_gotoxy(12,1); //lcd_puts("FAIL");
_0xAD:
	LDI  R30,LOW(12)
	CALL SUBOPT_0x5
; 0000 026E 
; 0000 026F     }
_0x6C:
; 0000 0270 
; 0000 0271     //putchar(0b00110010);
; 0000 0272    // unsigned char azimuth=data[0]&(0b01111111);
; 0000 0273     //int azimuth=(int)angle*2.8125;
; 0000 0274     lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x5
; 0000 0275     lcd_puts("AZ:");
	__POINTW2MN _0x22,1776
	CALL _lcd_puts
; 0000 0276 
; 0000 0277 
; 0000 0278 
; 0000 0279 
; 0000 027A 
; 0000 027B 
; 0000 027C }
	RJMP _0x8
; 0000 027D }
_0xAE:
	RJMP _0xAE
; .FEND

	.DSEG
_0x22:
	.BYTE 0x6F4
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
; .FSTART _putchar
	ST   -Y,R26
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
	RJMP _0x2080001
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G101:
; .FSTART __lcd_write_nibble_G101
	ST   -Y,R26
	IN   R30,0x1B
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LD   R30,Y
	ANDI R30,LOW(0xF0)
	OR   R30,R26
	OUT  0x1B,R30
	__DELAY_USB 7
	SBI  0x1B,2
	__DELAY_USB 7
	CBI  0x1B,2
	__DELAY_USB 7
	RJMP _0x2080001
; .FEND
__lcd_write_data:
; .FSTART __lcd_write_data
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G101
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G101
	__DELAY_USB 67
	RJMP _0x2080001
; .FEND
_lcd_gotoxy:
; .FSTART _lcd_gotoxy
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R12,Y+1
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
; .FEND
_lcd_clear:
; .FSTART _lcd_clear
	LDI  R26,LOW(2)
	CALL SUBOPT_0x6
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	CALL SUBOPT_0x6
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	MOV  R12,R30
	RET
; .FEND
_lcd_putchar:
; .FSTART _lcd_putchar
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020005
	LDS  R30,__lcd_maxx
	CP   R12,R30
	BRLO _0x2020004
_0x2020005:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,__lcd_y
	SUBI R26,-LOW(1)
	STS  __lcd_y,R26
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2020007
	RJMP _0x2080001
_0x2020007:
_0x2020004:
	INC  R12
	SBI  0x1B,0
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x1B,0
	RJMP _0x2080001
; .FEND
_lcd_puts:
; .FSTART _lcd_puts
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2020008:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x202000A
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2020008
_0x202000A:
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
_lcd_init:
; .FSTART _lcd_init
	ST   -Y,R26
	IN   R30,0x1A
	ORI  R30,LOW(0xF0)
	OUT  0x1A,R30
	SBI  0x1A,2
	SBI  0x1A,0
	SBI  0x1A,1
	CBI  0x1B,2
	CBI  0x1B,0
	CBI  0x1B,1
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	LDI  R26,LOW(20)
	LDI  R27,0
	CALL _delay_ms
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G101
	__DELAY_USB 133
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x2080001:
	ADIW R28,1
	RET
; .FEND

	.CSEG

	.CSEG

	.DSEG
_rx_buffer0:
	.BYTE 0x8
_data:
	.BYTE 0x1
__base_y_G101:
	.BYTE 0x4
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x0:
	CALL _putchar
	LDI  R26,LOW(250)
	LDI  R27,0
	CALL _delay_ms
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 127 TIMES, CODE SIZE REDUCTION:375 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 64 TIMES, CODE SIZE REDUCTION:186 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 48 TIMES, CODE SIZE REDUCTION:91 WORDS
SUBOPT_0x3:
	CALL _lcd_puts
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 48 TIMES, CODE SIZE REDUCTION:232 WORDS
SUBOPT_0x4:
	CALL _lcd_puts
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	CALL __lcd_write_data
	LDI  R26,LOW(3)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G101
	__DELAY_USB 133
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
